
// ASN1DecodeDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "ASN1Decode.h"
#include "ASN1DecodeDlg.h"
#include "afxdialogex.h"
#include "ASNFileParse.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif



// Ӧó򡰹ڡ˵ CAboutDlg Ի

class CAboutDlg : public CResizableDialog
{
public:
	CAboutDlg();

// Ի
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

// ʵ
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CResizableDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CResizableDialog)
END_MESSAGE_MAP()


// CASN1DecodeDlg Ի




CASN1DecodeDlg::CASN1DecodeDlg(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CASN1DecodeDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CASN1DecodeDlg::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CASN1DecodeDlg, CResizableDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_BROWSER, &CASN1DecodeDlg::OnBnClickedButtonBrowser)
	ON_WM_DROPFILES()
END_MESSAGE_MAP()


// CASN1DecodeDlg Ϣ

BOOL CASN1DecodeDlg::OnInitDialog()
{
	CResizableDialog::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	// TODO: ڴӶĳʼ
	AddAnchor(IDC_EDIT_FILE, TOP_LEFT, TOP_RIGHT);
	AddAnchor(IDC_BUTTON_BROWSER, TOP_RIGHT);
	AddAnchor(IDC_EDIT_OUTPUT, TOP_LEFT, BOTTOM_RIGHT);
	AddAnchor(IDC_EDIT_INFO, BOTTOM_LEFT, BOTTOM_RIGHT);

	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CASN1DecodeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CResizableDialog::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CASN1DecodeDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CResizableDialog::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CASN1DecodeDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

static CString GetASNFileTypeName(EM_CERT_TYPE emType)
{
	switch(emType)
	{
	case EM_CERTIFACATE:				return "֤";
	case EM_PUBLICKEY:					return "Կ";
	case EM_PRIVATEKEY_PKCS1:			return "˽ԿPKCS#1ʽ";
	case EM_PRIVATEKEY_PKCS8:			return "˽ԿPKCS#8ʽ";
	case EM_PRIVATEKEY_PKCS8_ENCRYPT:	return "˽ԿPKCS#8ʽ";
	case EM_KEY_PKCS12:					return "PKCS#12ʽ";
	default:
		return "";
	}
}

static BOOL CheckFileValid(const CString& cstrExt)
{
	if(0 == cstrExt.CompareNoCase("pem"))
		return TRUE;
	if(0 == cstrExt.CompareNoCase("der"))
		return TRUE;
	if(0 == cstrExt.CompareNoCase("cer"))
		return TRUE;
	if(0 == cstrExt.CompareNoCase("crl"))
		return TRUE;
	if(0 == cstrExt.CompareNoCase("p12"))
		return TRUE;
	if(0 == cstrExt.CompareNoCase("crt"))
		return TRUE;
	return FALSE;
}

#define SIZE_OUTPUT_BUFF		(1024*1024)
BOOL CASN1DecodeDlg::LoadFile(const CString& cstrPathFile)
{
	int iPos = cstrPathFile.ReverseFind('.');
	if(iPos < 0)
		return FALSE;
	CString cstrExt = cstrPathFile.Mid(iPos+1);
	if(!CheckFileValid(cstrExt))
	{
		MessageBox("δʶļʽ", "ʾ", MB_OK|MB_ICONERROR);
		return FALSE;
	}
	BOOL bPEM = (0 == cstrExt.CompareNoCase("pem"));
	CASNFileParse asnParse;
	BOOL bEncryped = FALSE;
 	if(!asnParse.LoadFile(cstrPathFile))
	{
		EM_CERT_TYPE emType = asnParse.GetFileType();
		if(bPEM && (emType ==  EM_PRIVATEKEY_PKCS8_ENCRYPT || emType == EM_KEY_PKCS12))
		{
			bEncryped = TRUE;
		}
		else
		{
			if(asnParse.IsEncryped())
			{
				MessageBox("Ѽܣ޷򿪣", "ʾ", MB_OK|MB_ICONERROR);
				return FALSE;
			}
			else
			{
				MessageBox("ļʽ󣬴ʧܣ", "ʾ", MB_OK|MB_ICONERROR);
				return FALSE;
			}
			
		}
	}

	char* pOutput = new char[SIZE_OUTPUT_BUFF];
	int iBuffPos = 0;
	asnParse.OutputASN2Buff(pOutput, SIZE_OUTPUT_BUFF, iBuffPos, asnParse.GetAsnSetX());
	*(pOutput+iBuffPos) = 0;
	SetDlgItemText(IDC_EDIT_OUTPUT, pOutput);

	TRACE("iBuffPos = %d\r\n", iBuffPos);
	delete pOutput;
	
	EM_CERT_TYPE emType = asnParse.GetFileType();
	CString cstrASNFileTypeName = GetASNFileTypeName(emType);
	CString cstrInfo;
	cstrInfo.Format("ļ: %s %s", cstrASNFileTypeName, bEncryped ? "Ѽ" : "");
	SetDlgItemText(IDC_EDIT_INFO, cstrInfo);
	
	return TRUE;
}

void CASN1DecodeDlg::OnBnClickedButtonBrowser()
{
	CString strFilter = "PEMʽ(*.pem;*.crt)|*.pem;*crt|derʽ(*.der;*.cer;*.crl)|*.der;*.cer;*.crl|p12ʽ(*.p12)|*.p12|ȫ(*.pem;*.crt;*.der;*.cer;*.crl;*.p12)|*.pem;*.crt;*.der;*.cer;*.crl;*.p12||";

	CFileDialog dlg(TRUE, _T(""), _T(""), OFN_HIDEREADONLY, strFilter, this);
	if(dlg.DoModal() != IDOK)
		return ;
	SetDlgItemText(IDC_EDIT_FILE, dlg.GetPathName());
	LoadFile(dlg.GetPathName());
}


void CASN1DecodeDlg::OnDropFiles(HDROP hDropInfo)
{
	CWaitCursor w;
	int iFileCount=::DragQueryFile(hDropInfo, 0xFFFFFFFF, NULL, 512);

	if(iFileCount > 1)
	{
		MessageBox("һļ", "ʾ", MB_OK|MB_ICONWARNING);
		return;
	}

	char szPathFile[_MAX_PATH] = {0};
	UINT nChars = ::DragQueryFile(hDropInfo, 0, szPathFile, _MAX_PATH); 

	SetDlgItemText(IDC_EDIT_FILE, szPathFile);
	LoadFile(szPathFile);
	::DragFinish(hDropInfo);
	CResizableDialog::OnDropFiles(hDropInfo);
}
